#include "Serial.h"
#include "Utilities.h"

//UART Driver
struct __using("jm_fullduplexserial.spin2") ser1;

unsigned char rxBuff[64];
char rxHead, rxTail;


void Serial_Init(long baudrate)
{
    //"Initing serial...\n";
    ser1.start(32, 33, 0, 9600);  //start(rxpin, txpin, mode, baud)
}

unsigned char Serial_Write(unsigned char c)
{
    ser1.tx(c);
    return 1;
}

unsigned char Serial_Read()
{
    unsigned char c;
    c = ser1.rxcheck();
    return c;
}

unsigned char Serial_Available()
{
    int n = ser1.available();
    return n;
}

unsigned char Serial_ReadBytes(char* buf, unsigned char len)
{
    _waitms(100); //P2 is fast... Need to wait a bit
    unsigned char cnt = 0;
    for (int i = 0; i < len; i++)
    {
        
        int c = ser1.rxcheck();
        if (c >= 0)
        {
            cnt++;
            buf[i] = c;
        }
        else
            break;
    }

    return cnt;
}

void Serial_Print(unsigned char* txt)
{
    short i = strlen(txt);
    
    for (int j = 0; j < i; j++)
    {
        ser1.tx(txt[j]);
    }
}

