//Testing Nextion Display 
//Copyright (C) Raymond Allen 2024
//MIT License

#include "Platform.h"
#include "Nextion.h"
#include <string.h>
#include <stdlib.h>
#include "NexConfig.h"

#include "Utilities.h"
#include "Serial.h"
#include "NexHardware.h"
#include "NexButton.h"
#include "NexNumber.h"
#include "NexObject.h"
#include "NexPage.h"
#include "NexProgressBar.h"
#include "NexSlider.h"
#include "NexText.h"
#include "NexTouch.h"

#include "Utilities.c"
#include "Serial.c"
#include "NexHardware.c"
#include "NexButton.c"
#include "NexNumber.c"
#include "NexPage.c"
#include "NexProgressBar.c"
#include "NexSlider.c"
#include "NexText.c"
#include "NexTouch.c"




struct NexObject button, slider;

struct NexObject* nex_listen_list[] = {
    &button,
    &slider };

long value;

#define buttonPageID 0
#define sliderPageID 0
#define buttonID 4
#define sliderID 1

void delay_ms(int ms)
{
    _waitms(ms);
}

void main()
{
    printf("Initializing Nextion...\n");
    nexInit();

    CreateNexObject(button, buttonPageID, buttonID, "b0");
    CreateNexObject(slider, sliderPageID, sliderID, "h0");

    

    NexSlider_getValue(&slider, &value);
    printf("slider value= %d\n", value);
    NexSlider_setValue(&slider, value + 20);

    NexTouch_attachPop(&button, buttonCallback, 0);
    NexTouch_attachPop(&slider, sliderCallback, 0);



    while (1)
    {
        nexLoop(nex_listen_list);
        delay_ms(50);
    }
}

void buttonCallback(void* ptr)
{
    //TODO
    printf("button released...\n");
}

void sliderCallback(void* ptr)
{
    //TODO
    printf("slider pushed...\n");
    NexSlider_getValue(&slider, &value);
    printf("slider value= %d\n", value);
}



